Global xr = 640, yr = 400
Graphics3D xr, yr, 0, 2
AppTitle ("MiniBCC #22 - Ladebildschirm")
fps_timer = CreateTimer(120)
SeedRnd MilliSecs()


	TFormFilter 0
	tmp_assets = LoadImage("assets.png")
	Global ASSETSCOUNT = ImageWidth(tmp_assets) / 16	
	Global assets = LoadAnimImage("assets.png", 16, 16, 0, ASSETSCOUNT)
	ScaleImage assets, 2, 2
	MidHandle assets

	Global mask = CreateImage(xr, yr)
	SetBuffer ImageBuffer(mask)
	Global durchmesser = 150
	Color 255, 255, 255
	Oval xr / 2 - 0.5 * durchmesser, yr * 0.666 - 0.5 * durchmesser, durchmesser, durchmesser
	Rect xr / 2 - 0.5 * durchmesser, 0, durchmesser, yr * 0.666
	Global BLACK = ReadPixel(0, 0, ImageBuffer(mask))
	Global WHITE = ReadPixel(xr / 2, yr * 0.666)

	Global Partikelebene = CreateImage(xr, yr)
	
	kreismaske = CreateImage(xr, yr)
	SetBuffer ImageBuffer(kreismaske)
	Color 0, 0, 0
	Rect 0, 0, xr, yr
	Color 255, 255, 255
	Oval xr / 2 - 0.5 * durchmesser, yr * 0.666 - 0.5 * durchmesser, durchmesser, durchmesser
	MaskImage kreismaske, 255, 255, 255
	

	Type Objekt
		Field n
		Field x#, y#, vx#, vy#, ax#, ay#
	End Type
	Global O.Objekt
	
	Type Partikel
		Field img
		Field x#, y#, vx#, vy#, ax#, ay#
	End Type
	Global P.Partikel
	
	
	Global FINISH = False

	SetBuffer BackBuffer()
	
	neuesObjekt()	

		Color 0, 0, 0
		txt$ = "PLAY"
		SetFont LoadFont("IMPACT", 72)
			
	Repeat
	
		Cls
		

	
		DrawImage partikelebene, 0, 0

	

		partikelUpdatenZeichnen()
		DrawImage kreismaske, 0, 0
		Text (xr - StringWidth(txt)) / 2, yr * 0.666 - StringHeight(txt) / 2, txt
		objekteUpdatenZeichnen()
		
		Flip(0)
		WaitTimer fps_timer


	
	Until KeyDown(1)
	
	End
	
	
Function neuesObjekt()
	If FINISH Then Return
	O = New Objekt
	O\n = Rand(0, ASSETSCOUNT - 1)
	If Rand(0, 1) Then O\x = xr / 2 + Rand(20, 50) Else O\x = xr / 2 - Rand(20, 50)
	O\y = 0
	O\vy = 2
	O\ay = 0.1

End Function


Function objekteUpdatenZeichnen()

	For O = Each Objekt
		O\vy = O\vy + O\ay
		O\y = O\y + O\vy
		;If O\vy > 20 Then O\vy = 20
		DrawImage assets, O\x, O\y, O\n
		If ReadPixel(O\x, O\y + O\vy + 7, ImageBuffer(mask)) = BLACK Or ReadPixel(O\x, O\y + O\vy + 7, ImageBuffer(partikelebene)) <> BLACK Then
			neuePartikel(O\n, O\x - 7, O\y - 7)
			If O\y <= yr * 0.666 - 0.7 * durchmesser Then FINISH = True			
			Delete O
			neuesObjekt()
		End If
	Next

End Function

Function neuePartikel(n, px, py)

	For x = 0 To 15
	For y = 0 To 15
		c = ReadPixel(x, y, ImageBuffer(assets, n))
		If c <> BLACK
			For i = 1 To 3
			P = New Partikel
			P\x = px + x
			P\y = py + y
			P\img = c
			P\vx = Rand(-5, 5)
			P\vy = Rand(-70, -10) / 100.
			Next
		End If
	Next
	Next

End Function

Function partikelUpdatenZeichnen()

	For P = Each Partikel
		P\vx = P\vx * 0.9
		P\vy = P\vy + 0.1
		P\x = P\x + P\vx
		P\y = P\y + P\vy
		For x = 0 To 1
		For y = 0 To 1
			WritePixel P\x + x, P\y + y, P\img
		Next
		Next
		If ReadPixel(P\x + P\vx, P\y + P\vy, ImageBuffer(mask)) <> WHITE Or ReadPixel(P\x + P\vx, P\y + P\vy, ImageBuffer(partikelebene)) <> BLACK Then
			;schauen, ob nach links oder rechts rutschen
			rutsch = False
			If ReadPixel(P\x + P\vx, P\y + P\vy, ImageBuffer(mask)) = WHITE Then
			If Rand(0, 1) = 0 Then

				If ReadPixel(P\x - 1, P\y + 1, ImageBuffer(partikelebene)) = BLACK Then
					P\x = P\x - 1
					P\vy = 1
					rutsch = True
				Else If ReadPixel(P\x + 1, P\y + 1, ImageBuffer(partikelebene)) = BLACK Then
					P\x = P\x + 1
					P\vy = 1
					rutsch = True
				Else If ReadPixel(P\x - 2, P\y + 1, ImageBuffer(partikelebene)) = BLACK Then
					P\x = P\x - 2
					P\vy = 1
					rutsch = True
				Else If ReadPixel(P\x + 2, P\y + 1, ImageBuffer(partikelebene)) = BLACK Then
					P\x = P\x + 2
					P\vy = 1
					rutsch = True

				End If
				
			Else
				If ReadPixel(P\x + 1, P\y + 1, ImageBuffer(partikelebene)) = BLACK Then
					P\x = P\x + 1
					P\vy = 1
					rutsch = True
				Else If ReadPixel(P\x - 1, P\y + 1, ImageBuffer(partikelebene)) = BLACK Then
					P\x = P\x - 1
					P\vy = 1
					rutsch = True
				Else If ReadPixel(P\x + 2, P\y + 1, ImageBuffer(partikelebene)) = BLACK Then
					P\x = P\x + 1
					P\vy = 1
					rutsch = True
				Else If ReadPixel(P\x - 2, P\y + 1, ImageBuffer(partikelebene)) = BLACK Then
					P\x = P\x - 1
					P\vy = 1
					rutsch = True
				End If			
			End If
			End If
		
			If rutsch = False Then
				For x = 0 To 1
				For y = 0 To 1				
					WritePixel(P\x + x, P\y + y - 1, P\img, ImageBuffer(partikelebene))
				Next
				Next
				Delete P
			End If
		End If
	Next

End Function